unit uProgress;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, FWEventLog;

type
  TdlgProgress = class(TForm)
    pbProgress: TProgressBar;
    btnCancel: TButton;
    lblInfo: TLabel;
    procedure btnCancelClick(Sender: TObject);
  private
    FStop: Boolean;
    FPreviosItemIndex: Integer;
    procedure OnEventRead(Sender: TObject;
      EventRecord: TFWEventLogRecord; var Stop: Boolean);
  public
    procedure LoadBackupLog(FilePath: String);
    procedure LoadEventLog(APPName: String);
  end;

var
  dlgProgress: TdlgProgress;

implementation

{$R *.dfm}

uses
  uMain;

{ TdlgProgress }

procedure TdlgProgress.LoadBackupLog(FilePath: String);
begin
  FStop := False;
  EnableWindow(EventLogDemoMainForm.Handle, False);
  try
    Show;
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    FPreviosItemIndex := -1;
    pbProgress.Max := EventLogDemoMainForm.EventLog.RecordCount(True);
    if not EventLogDemoMainForm.EventLog.Read(True, False, OnEventRead) then
      ShowMessage('   ')
    else
      EventLogDemoMainForm.RearrangelistView(EventLogDemoMainForm.lvEvents);
  finally
    EnableWindow(EventLogDemoMainForm.Handle, True);
    EventLogDemoMainForm.StatusBar.Panels.Items[0].Text :=
      ' : ' +
      IntToStr(EventLogDemoMainForm.lvEvents.Items.Count);
  end;
end;

procedure OnEventReadCallback(Sender: TObject;
  EventRecord: TFWEventLogRecord; var Stop: Boolean);
begin
  with EventLogDemoMainForm.lvEvents.Items.Add do
  begin
    Data := Pointer(EventRecord.Number);
    Caption := TFWEventLog.EventTypeToString(EventRecord.EventType);
    StateIndex := Integer(EventRecord.EventType);
    SubItems.Add(DateToStr(EventRecord.TimeWritten));
    SubItems.Add(TimeToStr(EventRecord.TimeWritten));
    SubItems.Add(EventRecord.SourceName);
    SubItems.Add(EventRecord.Category);
    SubItems.Add(IntToStr(EventRecord.EventID));
    SubItems.Add(EventRecord.Account);
    SubItems.Add(EventRecord.ComputerName);
  end;
  dlgProgress.lblInfo.Caption :=
    IntToStr(EventRecord.Number) + ': "' + EventRecord.SourceName + '"';
  dlgProgress.pbProgress.Position := dlgProgress.pbProgress.Position + 1;
  Application.ProcessMessages;
  Stop := dlgProgress.FStop;
  dlgProgress.FPreviosItemIndex := EventRecord.Number;
end;

procedure TdlgProgress.LoadEventLog(APPName: String);
begin
  FStop := False;
  EnableWindow(EventLogDemoMainForm.Handle, False);
  try
    Show;
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    FPreviosItemIndex := -1;
    pbProgress.Max := EventLogDemoMainForm.EventLog.RecordCount(False);
    if not EventLogDemoMainForm.EventLog.Read(False, False, @OnEventReadCallback) then
      ShowMessage('   ')
    else
      EventLogDemoMainForm.RearrangelistView(EventLogDemoMainForm.lvEvents);
  finally
    EnableWindow(EventLogDemoMainForm.Handle, True);
    EventLogDemoMainForm.StatusBar.Panels.Items[0].Text :=
      ' : ' +
      IntToStr(EventLogDemoMainForm.lvEvents.Items.Count);
  end;
end;

procedure TdlgProgress.OnEventRead(Sender: TObject;
  EventRecord: TFWEventLogRecord; var Stop: Boolean);
begin
  with EventLogDemoMainForm.lvEvents.Items.Add do
  begin
    Data := Pointer(EventRecord.Number);
    Caption := TFWEventLog.EventTypeToString(EventRecord.EventType);
    StateIndex := Integer(EventRecord.EventType);
    SubItems.Add(DateToStr(EventRecord.TimeWritten));
    SubItems.Add(TimeToStr(EventRecord.TimeWritten));
    SubItems.Add(EventRecord.SourceName);
    SubItems.Add(EventRecord.Category);
    SubItems.Add(IntToStr(EventRecord.EventID));
    SubItems.Add(EventRecord.Account);
    SubItems.Add(EventRecord.ComputerName);
  end;
  lblInfo.Caption := IntToStr(EventRecord.Number) + ': "' + EventRecord.SourceName + '"';
  pbProgress.Position := pbProgress.Position + 1;
  Stop := FStop;
  FPreviosItemIndex := EventRecord.Number;
  Application.ProcessMessages;
end;

procedure TdlgProgress.btnCancelClick(Sender: TObject);
begin
  FStop := True;
  Application.ProcessMessages;
end;

end.
